<template>
  <v-container fluid fill-height>
    <v-layout align-center justify-center>
      <v-flex xs12 sm8 md4>
        <v-card class="elevation-12">
          <v-toolbar dark color="primary">
            <v-toolbar-title>Choice OTP</v-toolbar-title>
          </v-toolbar>
          <v-card-text>
            <v-form>
              <v-select
                  :disabled="statusProgress"
                  v-model="choice_otp"
                  :items="list_otp"
                  label="Pilih OTP"
                  prepend-icon="list"
              >
              </v-select>
              <v-text-field
                  label="version"
                  :value="version"
                  prepend-icon="info"
                  readonly
              />
            </v-form>
          </v-card-text>
          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn color="primary" @click="doCheckOtp" :disabled="statusProgress">Next</v-btn>
          </v-card-actions>
        </v-card>
      </v-flex>
    </v-layout>
    <DlgMsg ref="dlgMsg" />
    <Loading ref="loading" :dlg-loading="statusProgress" />
  </v-container>
</template>

<script>
import DlgMsg from "../components/dialog/DlgMsg";
import Loading from "../components/dialog/Loading";

import request from "../utils/request";

export default {
  name: "ChoiceOtp",
  components: {
    DlgMsg,
    Loading,
  },
  data: function () {
    return {
      list_otp: [
          'Telegram',
          'Email'
      ],
      choice_otp: null,
      version: process.env.VUE_APP_VERSION,
      statusProgress: false,
    }
  },
  methods: {
    async doCheckOtp() {
      this.statusProgress = true
      if (this.choice_otp == null || this.choice_otp === '') {
        this.$refs.dlgMsg.doOpenMsg('Pilihan OTP Harus Dipilih!. ')
      } else {
        let username = this.$store.getters.getUsernameTmp
        let password = this.$store.getters.getPasswordTmp
        let choice = this.choice_otp
        let data_login = { username, password }
        await request({
          url: `/uaa/auth/check/${choice}`,
          data: data_login,
          method: 'post',
        }).then(resp => {
          let res = resp.data
          if (res.status === 'SUCCESS') {
            this.$router.push('/check/otp')
          } else {
            this.$refs.dlgMsg.doOpenMsg(res.message)
            console.log(res)
          }
        }).catch(async err => {
          console.log(err.response)
          let {status, data} = err.response
          if (status === 400 || status === 400) {
            if (data.code === 'invalid_user') {
              if (await this.$refs.dlgMsg.confirm(data.message)) {
                let token = data.data
                return await this.$store.dispatch('doLogoutForceCheck', {username, password, token, choice})
              }
            } else {
              this.$refs.dlgMsg.doOpenMsg(err.response.data.message)
            }
          } else {
            this.$refs.dlgMsg.doOpenMsg('ERROR EXCEPTION')
          }
        })
      }
      this.statusProgress = false
    }
  }
}
</script>

<style scoped>

</style>